
local L = PGFinderLocals

EnRT_VarimathrasOptions = CreateFrame("Frame", "EnRT_VarimathrasOptionsFrame", InterfaceOptionsFramePanelContainer)
EnRT_VarimathrasOptions.name = "Varimathras Module"
EnRT_VarimathrasOptions.parent = "|cFFFFFF00Antorus Modules"
EnRT_VarimathrasOptions:Hide()

local title = EnRT_VarimathrasOptions:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
title:SetPoint("TOP", 0, -16)
title:SetText(L.OPTIONS_TITLE)
	
local tabinfo = EnRT_VarimathrasOptions:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
tabinfo:SetPoint("TOPLEFT", 16, -16)
tabinfo:SetText(L.OPTIONS_VARIMATHRAS_TITLE)

local author = EnRT_VarimathrasOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
author:SetPoint("TOPLEFT", 450, -20)
author:SetText(L.OPTIONS_AUTHOR)

local version = EnRT_VarimathrasOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
version:SetPoint("TOPLEFT", author, "BOTTOMLEFT", 0, -10)
version:SetText(L.OPTIONS_VERSION)

local info = EnRT_VarimathrasOptions:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
info:SetPoint("TOPLEFT", 220, -10)
info:SetSize(350, 200)
info:SetText(L.OPTIONS_VARIMATHRAS_INFO)
info:SetWordWrap(true)

local enabledButton = CreateFrame("CheckButton", "EnRT_VarimathrasEnabledCheckButton", EnRT_VarimathrasOptions, "OptionsCheckButtonTemplate")
enabledButton:SetSize(26, 26)
enabledButton:SetPoint("TOPLEFT", 30, -90)
enabledButton:HookScript("OnClick", function(self)
	if self:GetChecked() then
		EnRT_VarimathrasEnabled = true
		PlaySound(856)
	else
		EnRT_VarimathrasEnabled = false
		PlaySound(857)
	end
end)

local enabledText = EnRT_VarimathrasOptions:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
enabledText:SetPoint("TOPLEFT", enabledButton, "TOPLEFT", 30, -7)
enabledText:SetText(L.OPTIONS_ENABLED)

local orderText = EnRT_VarimathrasOptions:CreateFontString(nil, "ARTWORK", "GameFontNormal")
orderText:SetPoint("TOPLEFT", 30, -140)
orderText:SetText(L.OPTIONS_VARIMATHRAS_ORDER)

local orderEdit = CreateFrame("EditBox", "EnRT_VarimathrasOrderEdit", EnRT_VarimathrasOptions, "InputBoxTemplate")
orderEdit:SetPoint("TOPLEFT", orderText, "TOPLEFT", 0, -2)
orderEdit:SetAutoFocus(false)
orderEdit:SetSize(250, 45)
orderEdit:SetText("")
orderEdit:SetScript("OnEscapePressed", function(self)
	self:SetText("")
	self:ClearFocus()
end)
orderEdit:SetScript("OnEnterPressed", function(self)
	local input = self:GetText()
	input = input:gsub("%s+", "")
	local order = {}
	if input ~= nil and input ~= "" then
		for pl in string.gmatch(input, '([^,]+)') do
	    	pl = pl:gsub("^%l", string.upper)
	    	table.insert(order, pl)
		end
	end
	EnRT_VarimathrasList = order
	orderEdit:SetText(input)
	self:ClearFocus()
end)
orderEdit:SetScript("OnTextChanged", function(self)
	local input = self:GetText()
	input = input:gsub("%s+", "")
	local order = {}
	if input ~= nil and input ~= "" then
		for pl in string.gmatch(input, '([^,]+)') do
	    	pl = pl:gsub("^%l", string.upper)
	    	table.insert(order, pl)
		end
	end
	EnRT_VarimathrasList = order
end)

local showListButton = CreateFrame("CheckButton", "EnRT_VarimathrasShowListCheckButton", EnRT_VarimathrasOptions, "OptionsCheckButtonTemplate")
showListButton:SetSize(26, 26)
showListButton:SetPoint("TOPLEFT", 30, -200)
showListButton:HookScript("OnClick", function(self)
	if self:GetChecked() then
		EnRT_VarimathrasListShow = true
		PlaySound(856)
	else
		EnRT_VarimathrasListShow = false
		PlaySound(857)
	end
end)

local showListText = EnRT_VarimathrasOptions:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
showListText:SetPoint("TOPLEFT", showListButton, "TOPLEFT", 30, -7)
showListText:SetText("Show Soak Order List")

local listToggleButton = CreateFrame("Button", "EnRT_VarimathrasListToggleButton", EnRT_VarimathrasOptions, "UIPanelButtonTemplate")
listToggleButton:SetSize(150, 35)
listToggleButton:SetPoint("TOPLEFT", 175, -195)
listToggleButton:SetText("Move Popup List")
listToggleButton:HookScript("OnClick", function(self)
	EnRT_VarimathrasListMove()
end)

EnRT_VarimathrasOptions:SetScript("OnShow", function(self)
	if EnRT_VarimathrasList ~= nil then
		local text = ""
		for k,v in pairs(EnRT_VarimathrasList) do
			if k == 1 then 
				text = v
			else
				text = text .. "," .. v
			end
		end
		orderEdit:SetText(text)
	end
	enabledButton:SetChecked(EnRT_VarimathrasEnabled)
	showListButton:SetChecked(EnRT_VarimathrasListShow)
end)

InterfaceOptions_AddCategory(EnRT_VarimathrasOptions)